### Method

# FwupdPlugin IOChannel read_raw

since: 1.2.2

#### Declaration [src]

    gboolean
    fu_io_channel_read_raw (
      FuIOChannel* self,
      guint8* buf,
      gsize bufsz,
      gsize* bytes_read,
      guint timeout_ms,
      FuIoChannelFlags flags,
      GError** error
    )

#### Description [src]

Reads bytes from the TTY, that will fail if exceeding `timeout_ms`.

Available since: 1.2.2

#### Parameters

`buf`

  Type: `guint8*`

  Optional buffer.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`bufsz`

  Type: `gsize`

  Size of `buf`.

`bytes_read`

  Type: `gsize*`

  Data written to `buf`.

  The argument will be set by the function.
  The argument can be set to `NULL` by the method.

`timeout_ms`

  Type: `guint`

  Timeout in ms.

`flags`

  Type: `FuIoChannelFlags`

  Channel flags, e.g. `FU_IO_CHANNEL_FLAG_SINGLE_SHOT`.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

A `GBytes`, or `NULL` for error.